NAME        - lc   list directory and file names in columns


SYNOPSIS    - lc [-fdsvhan1] [ directory ... ]


DESCRIPTION

    Lc lists the elements of the given directories. The elements are divided
    into the five basic types (files, directories, volume labels, hidden and
    system special files, and pipes) and are printed in alphabetical order.
    They are normally printed 5 to a line, preceeded by a title indicating
    the type, but the -1 option can be used to force single-column untitled
    output.

    If the argument list contains more than one name, the contents of the
    directories named in the list are displayed and all other names
    are ignored. If no directory is specified the current working directory
    is listed by default. The special entries ``.'' and ``..'' are normally
    not listed; the -a option causes them to be listed as well.

    The -n option turns off all output; this is useful when only the exit
    status is wanted. (The exit status is 0 if something would have been
    printed, 1 otherwise.)

    If any of the following option arguments are given,
    lc lists only those types of entries; otherwise, all entries are listed.

    The remaining options and their meanings are:

        -f      list ordinary files
        -d      list directories
        -s      list all special files
	-v	list volume labels
	-h	list hidden and system files

    Lc may be used with the substitution features of the Shell to select
    particular kinds of files (eg, directories) to take part in some
    processing, for example: (if you have a shell that allows this)

        ls -l    `lc -1d`
    This lists the contents of all sub-directories of the current directory.

BUGS:
   If you have too many files in a directory (folder), and you issue
   the command "lc *" from a shell, "lc" will complain.  However,
   in such cases, the command "lc" works just fine.
NOTE:
   Copyright University of Waterloo, 1978,1985,1987.
   Ported to the Atari ST by
	 Je'ro^me M. Lang	
	 Department of Applied Math
	 University of Waterloo
	 Waterloo, Ontario, N2L 3G1

	 jmlang@water.bitnet
